<?php

namespace Bspb\Pay\Tables;

use Bitrix\Main\Type\DateTime;

class Transaction extends EO_Transaction
{
    public static function find($infoPay)
    {
        $dTime = new DateTime();

        $data = TransactionTable::query()
            ->setFilter(array(
                'OrderNum' => $infoPay['OrderNum'],
                'PaymentId' => $infoPay['PaymentId'],
                'HandlerId' => $infoPay['PaymentSysId'],
                'IsCanceled' => false,
                'IsDecline' => false,
                'IsRefund' => false,
                'IsExpired' => false,
                '>DateCreate' => $dTime->add('-15 minutes'),
            ))
            ->setSelect(array('ID', 'BankUrl', 'BankOrderID', 'BankSessionId'))
            ->setOrder(array('ID' => 'desc'))
            ->fetchObject();
        return ($data) ? $data['BankUrl'] . "?ORDERID={$data['BankOrderID']}&SESSIONID={$data['BankSessionId']}" : null;
    }

    public static function findByBank($infoPay)
    {
        return TransactionTable::query()
            ->setFilter(array(
                'BankOrderID' => $infoPay['BankOrderID'],
                'BankSessionId' => $infoPay['BankSessionId'],
            ))
            ->setSelect(array('*'))
            ->setOrder(array('ID' => 'desc'))
            ->fetchObject();
    }
}
