<?php

namespace Bspb\Pay\Tables;

use Bitrix\Main\ORM\Data\DataManager;
use Bitrix\Main\ORM\Fields;
use Bitrix\Main\Type;
use Bitrix\Main\Entity\EventResult;
use Bitrix\Main\Entity\Event;

class TransactionTable extends DataManager
{
    public static function getTableName()
    {
        return 'bspb_transaction';
    }

    public static function getObjectClass()
    {
        return Transaction::class;
    }

    public static function getMap()
    {
        return array(
            new Fields\IntegerField('ID', array('primary' => true, 'autocomplete' => true)),
            new Fields\TextField('OrderNum', array('required' => true)),
            new Fields\IntegerField('PaymentId', array('required' => true)),
            new Fields\IntegerField('HandlerId', array('required' => true)),

            new Fields\TextField('BankOrderId', array('required' => true)),
            new Fields\TextField('BankSessionId', array('required' => true)),
            new Fields\TextField('BankUrl', array('required' => true)),

            new Fields\BooleanField('IsPaid', array('values' => [false, true])),
            new Fields\BooleanField('IsCanceled', array('values' => [false, true])),
            new Fields\BooleanField('IsDecline', array('values' => [false, true])),
            new Fields\BooleanField('IsRefund', array('values' => [false, true])),
            new Fields\BooleanField('IsExpired', array('values' => [false, true])),

            new Fields\DatetimeField('DateCreate', array('required' => true, 'default_value' => new Type\DateTime())),
            new Fields\DatetimeField('DateUpdate'),
        );
    }

    public static function onBeforeUpdate(Event $event)
    {
        $result = new EventResult();
        $result->modifyFields(array('DateUpdate' => new Type\DateTime()));
        return $result;
    }
}
